'- - - - - - - - - - - - - - - ANTTOWER.BAS- - - - - - - -30Dec2002- - - - -'
' Original code written by Peter A. Stark K2OAW for the magazine:           '
' "73 Amateur Radio Today", March 1997, page 68                             '
' Modified and adapted to QuickBasic v4.5 by Richard M. Bender W3SYY 7/23/97'
' Adapted to Liberty Basic v3.x   26 December 2002 by W3SYY                 '
' Assume transmitter is in the center and towers are placed around it.      '
' Example: two towers, one north 0.25 wavelength, one south 0.25 wavelength '
'          0 dB loss for both coax cables also of 0.25 wavelengths          '
'          Should give a horizontal figure-8 pattern!                       '
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'

NOMAINWIN
DIM ColorType$(7)
DIM TowerAngle(5)
DIM TowerDistance(5)
DIM CableLoss(5)
DIM CableLength(5)
DIM x(5)
DIM y(5)

Pi = 3.1415927                  ' define PI and variations
TwoPi = 2 * Pi
deg2rad = Pi / 180
xbase = 210: ybase = 210
xscale = 2: yscale = 2
ColorType$(1) = "yellow"
ColorType$(2) = "red"
ColorType$(3) = "pink"
ColorType$(4) = "blue"
ColorType$(5) = "green"
ColorType$(6) = "cyan"
ColorType$(7) = "white"

WindowWidth = 720 : WindowHeight = 490
UpperLeftX = INT((DisplayWidth-WindowWidth)/2)
UpperLeftY = INT((DisplayHeight-WindowHeight)/2)

    BackgroundColor$ = "buttonface"
    ForegroundColor$ = "black"
    TextboxColor$ = "white"

    statictext #main.tower1, "1", 5, 52,  7, 20     ' tower 1 info
    textbox #main.angle1,        25, 52, 45, 25
    textbox #main.distance1,     85, 52, 45, 25
    textbox #main.cablelen1,    145, 52, 45, 25
    textbox #main.cableloss1,   205, 52, 45, 25

    statictext #main.tower2, "2", 5, 82,  7, 20     ' tower 2 info
    textbox #main.angle2,        25, 82, 45, 25
    textbox #main.distance2,     85, 82, 45, 25
    textbox #main.cablelen2,    145, 82, 45, 25
    textbox #main.cableloss2,   205, 82, 45, 25

    statictext #main.tower3, "3", 5, 112,  7, 20    ' tower 3 info
    textbox #main.angle3,        25, 112, 45, 25
    textbox #main.distance3,     85, 112, 45, 25
    textbox #main.cablelen3,    145, 112, 45, 25
    textbox #main.cableloss3,   205, 112, 45, 25

    statictext #main.tower4, "4", 5, 142,  7, 20    ' tower 4 info
    textbox #main.angle4,        25, 142, 45, 25
    textbox #main.distance4,     85, 142, 45, 25
    textbox #main.cablelen4,    145, 142, 45, 25
    textbox #main.cableloss4,   205, 142, 45, 25

    statictext #main.tower5, "5", 5, 172,  7, 20    ' tower 5 info
    textbox #main.angle5,        25, 172, 45, 25
    textbox #main.distance5,     85, 172, 45, 25
    textbox #main.cablelen5,    145, 172, 45, 25
    textbox #main.cableloss5,   205, 172, 45, 25

    statictext #main.statictext26, "Tower",    28, 15, 40, 20
    statictext #main.statictext29, "Tower",    89, 15, 40, 20
    statictext #main.statictext27, "Coax",    150, 15, 35, 20
    statictext #main.statictext28, "Coax",    210, 15, 35, 20
    statictext #main.statictext26, "Angle",    28, 32, 35, 20
    statictext #main.statictext29, "Distance", 83, 32, 53, 20
    statictext #main.statictext27, "Length",  148, 32, 40, 20
    statictext #main.statictext28, "Loss",    210, 32, 29, 20

    button #main.plot, "Plot Pattern", [PlotButton], UL, 95, 217, 85, 25
    button #main.reset, "Clear Plots", [ResetButton], UL, 95, 262, 85, 25
    button #main.quit, "Quit?", [QuitButton], UL, 115, 322, 44, 25
    MENU #main, "&Info","&Help",[MenuHelp],"&About",[MenuAbout]
    GRAPHICBOX #main.gbox,270, 1, 420, 420

    OPEN "Antenna Tower Phasing Patterns v1.0" for window as #main
    PRINT #main, "font ms_sans_serif 0 16"
    PRINT #main, "trapclose [QuitButton]"
    PRINT #main.gbox, "down; fill black; flush"   ' default background color


[ResetButton]
  PRINT #main.gbox, "cls; down; fill Black"  ' set background color
  PRINT #main.gbox, "color white"            ' set pen color for grid
  GOSUB [grid]                               ' draw grid
  ColorLevel = 0                             ' initialize pen color

[loop]
  PRINT #main.angle1, "!setfocus";
  wait

[PlotButton]
   print #main.angle1, "!contents? temp"     ' get respective tower angles
   TowerAngle(1) = temp
   print #main.angle2, "!contents? temp"
   TowerAngle(2) = temp
   print #main.angle3, "!contents? temp"
   TowerAngle(3) = temp
   print #main.angle4, "!contents? temp"
   TowerAngle(4) = temp
   print #main.angle5, "!contents? temp"
   TowerAngle(5) = temp

   print #main.distance1, "!contents? temp"  ' get tower distances from origin
   TowerDistance(1) = temp                   ' in wavelengths
   print #main.distance2, "!contents? temp"
   TowerDistance(2) = temp
   print #main.distance3, "!contents? temp"
   TowerDistance(3) = temp
   print #main.distance4, "!contents? temp"
   TowerDistance(4) = temp
   print #main.distance5, "!contents? temp"
   TowerDistance(5) = temp

   print #main.cablelen1, "!contents? temp"  ' get cable lengths from origin
   CableLength(1) = temp                     ' in wavelengths
   print #main.cablelen2, "!contents? temp"
   CableLength(2) = temp
   print #main.cablelen3, "!contents? temp"
   CableLength(3) = temp
   print #main.cablelen4, "!contents? temp"
   CableLength(4) = temp
   print #main.cablelen5, "!contents? temp"
   CableLength(5) = temp

   print #main.cableloss1, "!contents? temp" ' get cable losses in dB
   CableLoss(1) = temp
   print #main.cableloss2, "!contents? temp"
   CableLoss(2) = temp
   print #main.cableloss3, "!contents? temp"
   CableLoss(3) = temp
   print #main.cableloss4, "!contents? temp"
   CableLoss(4) = temp
   print #main.cableloss5, "!contents? temp"
   CableLoss(5) = temp

   NumberOfTowers = 0
   FOR i = 1 TO 5
     CableLoss(i) = 10 ^ (CableLoss(i) / 20)
     IF TowerDistance(i) > 0 THEN NumberOfTowers = i
     y(i) = TowerDistance(i) * COS(TowerAngle(i) * deg2rad)
     x(i) = TowerDistance(i) * SIN(TowerAngle(i) * deg2rad)
     IF CableLength(i)< TowerDistance(i) THEN
       NOTICE "                 **ERROR**" + CHR$(13) +_
              "Cable length is less than tower distance!"
       GOTO [loop]
     END IF
     IF TowerAngle(i) > 360 THEN
       NOTICE "                 **ERROR**" + CHR$(13) +_
              "Tower angle must be less than 360 degrees!"
       GOTO [loop]
     END IF
   NEXT i

  IF ColorLevel = 7 THEN
    NOTICE "                 **WARNING**" + CHR$(13) +_
           "All plot colors have been used!" + CHR$(13)+_
           "Current color will be used."
  ELSE
    ColorLevel = ColorLevel + 1
  END IF
  CurrentColor$ = ColorType$(ColorLevel)
  PRINT #main.gbox, "color ";CurrentColor$

'--calculate and plot
  FOR d = 0 TO 360                ' one degree increment plotting
    xsum = 0: ysum = 0
    xr = 1000 * COS(d * deg2rad)                      ' position of observer
    yr = 1000 * SIN(d * deg2rad)
    FOR r = 1 TO NumberOfTowers
      dist = SQR((xr - x(r)) ^ 2 + (yr - y(r)) ^ 2)   ' distance to tower
      phase = dist + CableLength(r)
      mag = CableLoss(r) * 3000 / SQR(dist) / NumberOfTowers
      xsum = xsum + mag * COS(phase * TwoPi)
      ysum = ysum + mag * SIN(phase * TwoPi)
    NEXT r
    total = SQR(xsum ^ 2 + ysum ^ 2)
    xpt = xbase + xscale * (total * COS(d * deg2rad)) ' resultant signal strength
    ypt = ybase - yscale * (total * SIN(d * deg2rad))
    IF d > 0 THEN PRINT #main.gbox, "line ";Xp;" ";Yp;" ";xpt;" ";ypt
      Xp = xpt
      Yp = ypt
  NEXT d
  GOTO [loop]

[grid]
  PRINT #main.gbox, "line ";xbase-210;" ";ybase;" ";xbase+210;" ";ybase
  PRINT #main.gbox, "line ";xbase;" ";ybase-210;" ";xbase;" ";ybase+210
  RETURN

[MenuHelp]               '- - - HELP - display help screen
  NOTICE "*** H E L P ***"+CHR$(13)+_
         "Program plots the resultant horizontal E-field pattern of a group of"+CHR$(13)+_
         "antenna towers spaced at various distances and angles from a central" + chr$(13) +_
         "transmitter location.  All distances and lengths are in wavelengths,"+CHR$(13)+_
         "angles in degrees and coax losses in dB."+CHR$(13)+CHR$(13)+_
         "An angle of zero degrees represents a north location."+CHR$(13)+_
         "Using the <Clear Plots> button will erase all patterns."+chr$(13)+_
         "Enter tower information for one or more towers and press <Plot Pattern>"+chr$(13) +_
         "button for display.  Enter new tower data and plot another pattern"+chr$(13)+_
         "in a different color overlaying the previous plot(s)."+chr$(13)+CHR$(13)+_
         "Example: Two towers, one north at 0.25 wavelengths, one south also"+CHR$(13)+_
         "at 0.25 wavelengths, both coax cables of 0.25 wavelengths length"+CHR$(13)+_
         "and zero dB loss will give a horizontal figure-eight pattern!"+CHR$(13)+_
         "Changing all 0.25s to 0.5 will produce a four-lobe pattern!"+CHR$(13)+_
         "...........Have fun!"
  GOTO [loop]

[MenuAbout]
  NOTICE "ANTENNA TOWER PHASING EFFECTS:" + chr$(13) +_
         "version 1.0" + chr$(13) +_
         "by Richard M. Bender W3SYY" + chr$(13) +_
         "e-mail: w3syy@arrl.net"+CHR$(13)+_
         "26 December 2002"
  GOTO [loop]

[QuitButton]
  CONFIRM "Are you sure you want to QUIT?";Answer$
  IF Answer$ = "no" then GOTO [loop]
  CLOSE #main
  END

